/*
 * nanoGallery v3.1.0
 * Plugin for GetSimple CMS by Christophe Brisbois
 * http://www.brisbois.fr
 * 
 * External components:
 *  - jQuery (http://www.jquery.com)
 *  - fancybox (http://www.fancybox.net)
 */


var nG = {

	user: "",
	settingsObj: null,
	containerFolder : null,
	containerBreadcrumb : null,
	path2timthumb : "",
	tW : 230,
	tH : 154,
	picasaThumbSize : 64,
	picasaThumbAvailableSizes : new Array(32, 48, 64, 72, 94, 104, 110, 128, 144, 150, 160, 200, 220, 288, 320, 400, 512, 576, 640, 720, 800, 912, 1024, 1152, 1280, 1440, 1600),
	flickrThumbSize : 's',
	flickrThumbAvailableSizes : new Array(75,100,150,240,320,500,640,800,1024),		//see http://www.flickr.com/services/api/misc.urls.html
	flickrThumbAvailableSizesStr : new Array('s','t','q','m','n','-','z','c','b'),
	displayCaption : true,
	blackList: null,
	itemInfo : new Array(),
	flickrApiKey:"2f0e634b471fdb47446abcb9c5afebdc",
	
	
	Initiate : function(elementID, params, instance) {
	
		if( params.thumbnailHeight !== undefined ) { nG.tH=params.thumbnailHeight; }
		if( params.thumbnailWidth !== undefined ) { nG.tW=params.thumbnailWidth; }
		if( params.displayCaption !== undefined ) { nG.displayCaption=params.displayCaption; }
		if( params.blackList !== undefined ) { nG.blackList=params.blackList.toUpperCase().split('|'); }
		
		nG.containerBreadcrumb =jQuery('<div id="nanoGalleryBreadcrumb"></div>').appendTo('#'+elementID);
		nG.containerFolder =jQuery('<div id="nanoGalleryContainer"></div>').appendTo('#'+elementID);
		nG.path2timthumb = ""; //timthumbFolder;

		
		if( nG.tW > nG.tH ) { si=nG.tW; }
		else { si=nG.tH; }

		nG.user = params.userID;
		switch(params.kind) {
			case "flickr":
				for( i=0; i<nG.flickrThumbAvailableSizes.length; i++) {
					nG.flickrThumbSize=nG.flickrThumbAvailableSizesStr[i];
					if( si < nG.flickrThumbAvailableSizes[i] ) {
						break;
					}
				}
				nG.FlickrGetItems('','Home');
				break;
			default:
				for( i=0; i<nG.picasaThumbAvailableSizes.length; i++) {
					nG.picasaThumbSize=nG.picasaThumbAvailableSizes[i];
					if( si < nG.picasaThumbAvailableSizes[i] ) {
						break;
					}
				}
				nG.PicasaGetItems('','Home');
				break;
		}
	},
	

	// ##### FLICKR STORAGE #####
	FlickrGetItems : function ( itemID, albumLabel ) {
		var obj=null;
	
		// breadcrumb
		if( albumLabel != "" ) {
			if( jQuery(nG.containerBreadcrumb).children().length > 0 ) {
				jQuery('<div class="separator">&nbsp;>&nbsp;</div>').appendTo(nG.containerBreadcrumb);
			}
			var newDiv =jQuery('<div class="folder">'+albumLabel+'</div>').appendTo(nG.containerBreadcrumb);
			jQuery(newDiv).data("path",itemID);
			newDiv.click(function() {
				var folder=jQuery(this).data("path");
				jQuery(this).nextAll().remove();
				nG.FlickrGetItems(folder,'');
			});;
		}

		
		jQuery(nG.containerFolder).children().remove();

		// RETRIEVE PHOTOSETS
		if( itemID == '' ) {
			var url = "http://api.flickr.com/services/rest/?&method=flickr.photosets.getList&api_key=" + nG.flickrApiKey + "&user_id="+nG.user+"&format=json&jsoncallback=?";
			kind='album';

			// get the content and display it
			jQuery.ajaxSetup({ cache: false });
			jQuery.getJSON(url, function(data) {
				nG.settingsObj = data;
				nG.itemInfo=new Array();


				jQuery.each(data.photosets.photoset, function(i,item){
					//Get the title 
					itemTitle = item.title._content;
					itemID=item.id;
					//Get the description
					itemDescription='';
					if (item.description._content != undefined)
						itemDescription=item.description._content;
					itemThumbURL = "http://farm" + item.farm + ".staticflickr.com/" + item.server + "/" + item.primary + "_" + item.secret + "_"+nG.flickrThumbSize+".jpg";
					imgUrl=''
					itemKind=kind;

					if( nG.blackList !== null ) {
						//blackList : ignore album cointaining one of the specified keyword in the title
						var found=false;
						var s=itemTitle.toUpperCase();
						for( var j=0; j<nG.blackList.length; j++) {
							if( s.indexOf(nG.blackList[j]) !== -1 ) { return true; }
						}
					}

					var newDiv =jQuery('<div class="container"></div>').appendTo(nG.containerFolder);
					jQuery(newDiv).append('<div class="imgcont"><img class="image" src="'+itemThumbURL+'"></div>');

					jQuery(newDiv).append('<div class="labelFolder">'+itemTitle+'</div>');
					nG.itemInfo[i]=new Array(itemTitle, itemThumbURL, itemID, itemDescription,itemKind);
					
					nG.SetContainerHoover(newDiv);

					jQuery(newDiv).data("index",i);
					newDiv.click(function() {
						var n=jQuery(this).data("index");
						nG.FlickrGetItems(nG.itemInfo[i][2],nG.itemInfo[i][0]);
					});
				});
				nG.SetContainerSize();

			});		
			
			
		}
		// RETRIEVE PHOTOS
		else {
			var url = "http://api.flickr.com/services/rest/?&method=flickr.photosets.getPhotos&api_key=" + nG.flickrApiKey + "&photoset_id="+itemID+"&extras=views,url_s,url_o,url_m&format=json&jsoncallback=?";
			kind='photo';

			// get the content and display it
			jQuery.ajaxSetup({ cache: false });
			jQuery.getJSON(url, function(data) {
				nG.settingsObj = data;
				nG.itemInfo=new Array();

				jQuery.each(data.photoset.photo, function(i,item){
					//Get the title 
					itemTitle = item.title._content;
					itemID=item.id;
					//Get the description
					itemDescription='';
					itemThumbURL = "http://farm" + item.farm + ".staticflickr.com/" + item.server + "/" + item.id +"_" + item.secret + "_"+nG.flickrThumbSize+".jpg";
					imgUrl = "http://farm" + item.farm + ".staticflickr.com/" + item.server + "/" + item.id + "_" + item.secret + "_o.jpg";


					itemKind=kind;

					var newDiv =jQuery('<div class="container"></div>').appendTo(nG.containerFolder);
					jQuery(newDiv).append('<div class="imgcont"><img class="image" src="'+itemThumbURL+'"></div>');

					var s=itemTitle;
					if( s ===undefined || s.length == 0 || nG.displayCaption == false ) { s=i+1; }
					jQuery(newDiv).append('<div class="labelImage">'+s+'</div>');
					nG.itemInfo[i]=new Array(itemTitle, itemThumbURL, imgUrl, itemDescription, itemKind);

					nG.SetContainerHoover(newDiv);

					jQuery(newDiv).data("index",i);
					newDiv.click(function() { nG.OpenFancyBox(this); });
				});
				nG.SetContainerSize();
			});		
		}
	},

	
	// ##### PICASA STORAGE #####
	PicasaGetItems : function ( itemID, albumLabel ) {
		jQuery(nG.containerFolder).children().remove();

		if( itemID == '' ) {
			var url = 'http://picasaweb.google.com/data/feed/api/user/'+nG.user+'?alt=json&kind=album&thumbsize='+nG.picasaThumbSize;
			kind='album';
		}
		else {
			var url = 'http://picasaweb.google.com/data/feed/api/user/'+nG.user+'/albumid/'+itemID+'?alt=json&kind=photo&thumbsize='+nG.picasaThumbSize+'&imgmax=d';
			kind='photo';
		}

		// breadcrumb
		if( albumLabel != "" ) {
			if( jQuery(nG.containerBreadcrumb).children().length > 0 ) {
				jQuery('<div class="separator">&nbsp;>&nbsp;</div>').appendTo(nG.containerBreadcrumb);
			}
			var newDiv =jQuery('<div class="folder">'+albumLabel+'</div>').appendTo(nG.containerBreadcrumb);
			jQuery(newDiv).data("path",itemID);
			newDiv.click(function() {
				var folder=jQuery(this).data("path");
				jQuery(this).nextAll().remove();
				nG.PicasaGetItems(folder,'');
			});;
		}

		
		
		// get the content and display it
		jQuery.ajaxSetup({ cache: false });
		jQuery.getJSON(url, function(data) {
			nG.settingsObj = data;
			nG.itemInfo=new Array();
			
			jQuery.each(data.feed.entry, function(i,data){
				//Get the title 
				itemTitle = data.media$group.media$title.$t;
				//Get the URL of the thumbnail
				itemThumbURL = data.media$group.media$thumbnail[0].url;
				//Get the ID 
				itemID = data.id.$t;
				itemID = itemID.split('/')[9].split('?')[0];
				//Get the description
				itemDescription = data.media$group.media$description.$t;
				imgUrl=data.media$group.media$content[0].url
				itemKind=kind;

				if( nG.blackList !== null && kind == 'album' ) {
					//blackList : ignore album cointaining one of the specified keyword in the title
					var found=false;
					var s=itemTitle.toUpperCase();
					for( var j=0; j<nG.blackList.length; j++) {
						if( s.indexOf(nG.blackList[j]) !== -1 ) { return true; }
					}
				}
				
				var newDiv =jQuery('<div class="container"></div>').appendTo(nG.containerFolder);
				jQuery(newDiv).append('<div class="imgcont"><img class="image" src="'+itemThumbURL+'"></div>');
				if( kind == 'album' ) {
					jQuery(newDiv).append('<div class="labelFolder">'+itemTitle+'</div>');
					nG.itemInfo[i]=new Array(itemTitle, itemThumbURL, itemID, itemDescription,itemKind);
				}
				else {
					var s=itemDescription;
					if( s.length == 0 || nG.displayCaption == false ) { s=i+1; }
					jQuery(newDiv).append('<div class="labelImage">'+s+'</div>');
					nG.itemInfo[i]=new Array(itemTitle, itemThumbURL, imgUrl, itemDescription, itemKind);
				}

				nG.SetContainerHoover(newDiv);

				jQuery(newDiv).data("index",i);
				newDiv.click(function() {
					var n=jQuery(this).data("index");
					if( nG.itemInfo[n][4] == 'album' ) {
						nG.PicasaGetItems(nG.itemInfo[i][2],nG.itemInfo[i][0]);
					}
					else {
						nG.OpenFancyBox(this);
					}
				});
			});
			nG.SetContainerSize();

		})
		.error( function(XMLHttpRequest, textStatus, errorThrown) {
			alert("Error with Picasa: " + textStatus);
		});
	},
	
	OpenFancyBox : function(element) {
		var n=jQuery(element).data("index");
		var lstImages=new Array();
		lstImages[0]=nG.itemInfo[n][2];
		for( var j=n+1; j<nG.itemInfo.length; j++) {
			lstImages[lstImages.length]=nG.itemInfo[j][2];
		}
		for( var j=0; j<n; j++) {
			lstImages[lstImages.length]=nG.itemInfo[j][2];
		}
		jQuery.fancybox.open(lstImages,{'autoPlay':false, 'nextEffect':'fade', 'prevEffect':'fade','scrolling':'no',
			helpers		: {	buttons	: { 'position' : 'bottom'} }
		});
	},
	
	SetContainerSize : function() {
		jQuery(nG.containerFolder).find('.imgcont').css('width',nG.tW);
		jQuery(nG.containerFolder).find('.imgcont').css('height',nG.tH);
		jQuery(nG.containerFolder).find('img').css('maxWidth',nG.tW);
		jQuery(nG.containerFolder).find('img').css('maxHeight',nG.tH);
	},
	
	SetContainerHoover : function (newDiv) {
		jQuery(newDiv).hover(
			function() { jQuery(this).stop().animate({"borderBottomColor": "#888","borderTopColor": "#888","borderLeftColor": "#aaa","borderRightColor": "#888"}, "fast"); },
			function() { jQuery(this).stop().animate({"borderBottomColor": "#000","borderTopColor": "#000","borderLeftColor": "#000","borderRightColor": "#000"}, "fast"); }
		);
	}

		

}